---
title: disabled
slug: Web/HTML/Attributes/disabled
tags:
  - Attribute
  - Attributes
  - Constraint validation
  - Forms
  - required
---
<p><span class="seoSummary">The Boolean <code><strong>disabled</strong></code> attribute, when present, makes the element not mutable, focusable, or even submitted with the form. The user can neither edit nor focus on the control, nor its form control descendants.</span> If the <code>disabled</code> attribute is specified on a form control, the element and its form control descendants do not participate in constraint validation. Often browsers grey out such controls and it won't receive any browsing events, like mouse clicks or focus-related ones.</p>

<p>The <code>disabled</code> attribute is supported by {{ HTMLElement("button") }}, {{ HTMLElement("command") }}, {{ HTMLElement("fieldset") }}, {{ HTMLElement("keygen") }}, {{ HTMLElement("optgroup") }}, {{ HTMLElement("option") }}, {{ HTMLElement("select") }}, {{ HTMLElement("textarea") }} and {{ HTMLElement("input")}}.</p>

<p>This Boolean disabled attribute indicates that the user cannot interact with the control or its descendant controls. If this attribute is not specified, the control inherits its setting from the containing element, for example <code>fieldset</code>; if there is no containing element with the <code>disabled</code> attribute set, and the control itself does not have the attribute, then the control is enabled. If declared on an {{ HTMLElement("optgroup") }}, the select is still interactive (unless otherwise disabled), but none of the items in the option group are selectable.</p>

<div class="notecard note">
<p>Note: If a {{ HTMLElement("fieldset") }} is disabled, the descendant form controls are all disabled, with the exception of form controls within the {{ HTMLElement("legend") }}.</p>
</div>

<p>When a supporting element has the <code>disabled</code> attribute applied, the {{cssxref(":disabled")}} pseudo-class also applies to it. Conversely, elements that support the <code>disabled</code> attribute but don't have the attribute set match the {{cssxref(":enabled")}} pseudo-class.</p>

<p>This Boolean attribute prevents the user from interacting with the button. If this attribute isn't set, the button can still be disabled from a containing element, for example <code>{{htmlelement('fieldset')}}</code>; if there is no containing element with the <code>disabled</code> attribute set, then the button is enabled.</p>

<p>Firefox will, unlike other browsers, persist the dynamic disabled state of a <code>{{htmlelement('button')}}</code> across page loads. Use the <code><a href="/en-US/docs/Web/HTML/Attribute/autocomplete">autocomplete</a></code> attribute to control this feature.</p>

<h3 id="Attribute_interactions">Attribute interactions</h3>

<p>The difference between <code>disabled</code> and <code><a href="/en-US/docs/Web/HTML/Attributes/readonly">readonly</a></code> is that read-only controls can still function and are still focusable, whereas disabled controls can not receive focus and are not submitted with the form and generally do not function as controls until they are enabled.</p>

<p>Because a disabled field cannot have its value changed, <code><a href="/en-US/docs/Web/HTML/Attributes/required">required</a></code> does not have any effect on inputs with the <code>disabled</code> attribute also specified. Additionally, since the elements become immutable, most other attributes, such as <code><a href="/en-US/docs/Web/HTML/Attributes/pattern">pattern</a></code>, have no effect, until the control is enabled.</p>

<div class="notecard note">
<p><strong>Note:</strong> The <code>required</code> attribute is not permitted on inputs with the <code>disabled</code> attribute specified.</p>
</div>

<h3 id="Usability">Usability</h3>

<p>Browsers display disabled form controls greyed as disabled form controls are immutable, won't receive focus or any browsing events, like mouse clicks or focus-related ones, and aren't submitted with the form.</p>

<p>If present on a supporting elements, the <code>{{cssxref(':disabled')}}</code> pseudo class will match. If the attribute is not included, the <code>{{cssxref(':enabled')}}</code> pseudo class will match. If the element doesn't support the disabled attribute, the attribute will have no effect, including not leading to being matched by the <code>:disabled</code> and <code>:enabled</code> pseudo classes.</p>

<h3 id="Constraint_validation">Constraint validation</h3>

<p>If the element is <code>disabled</code>, then the element's value can not receive focus and cannot be updated by the user, and does not participate in constraint validation.</p>

<h2 id="Examples">Examples</h2>

<p>When form controls are disabled, many browsers will display them in a lighter, greyed-out color by default. Here are examples of a disabled checkbox, radio button, {{ HTMLElement("option") }} and {{ HTMLElement("optgroup") }}, as well as some form controls that are disabled via the disabled attribute set on the ancestor <code>{{ HTMLElement("fieldset")}}</code>  element. The {{ HTMLElement("option") }}s are disabled, but the {{ HTMLElement("select") }} itself is not. We could have disable the entire {{ HTMLElement("select") }} by adding the attribute to that element rather than its descendants.</p>

<div>
<pre class="brush: html notranslate">&lt;fieldset&gt;
  &lt;legend&gt;Checkboxes&lt;/legend&gt;
  &lt;p&gt;&lt;label&gt;
    &lt;input type="checkbox" name="chbox" value="regular"&gt; Regular
  &lt;/label&gt;&lt;/p&gt;
  &lt;p&gt;&lt;label&gt;
    &lt;input type="checkbox" name="chbox" value="disabled" disabled&gt; disabled
  &lt;/label&gt;&lt;/p&gt;
&lt;/fieldset&gt;

&lt;fieldset&gt;
  &lt;legend&gt;Radio buttons&lt;/legend&gt;
  &lt;p&gt;&lt;label&gt;
    &lt;input type="radio" name="radio" value="regular"&gt; Regular
  &lt;/label&gt;&lt;/p&gt;
  &lt;p&gt;&lt;label&gt;
    &lt;input type="radio" name="radio" value="disabled" disabled&gt; disabled
  &lt;/label&gt;&lt;/p&gt;
&lt;/fieldset&gt;

&lt;p&gt;
 &lt;label&gt;Select an option:
  &lt;select&gt;
    &lt;optgroup label="Group 1"&gt;
      &lt;option&gt;Option 1.1&lt;/option&gt;
    &lt;/optgroup&gt;
    &lt;optgroup label="Group 2"&gt;
      &lt;option&gt;Option 2.1&lt;/option&gt;
      &lt;option disabled&gt;Option 2.2&lt;/option&gt;
      &lt;option&gt;Option 2.3&lt;/option&gt;
    &lt;/optgroup&gt;
    &lt;optgroup label="Group 3" disabled&gt;
      &lt;option&gt;Disabled 3.1&lt;/option&gt;
      &lt;option&gt;Disabled 3.2&lt;/option&gt;
      &lt;option&gt;Disabled 3.3&lt;/option&gt;
    &lt;/optgroup&gt;
  &lt;/select&gt;
 &lt;/label&gt;
&lt;/p&gt;

&lt;fieldset disabled&gt;
  &lt;legend&gt;Disabled fieldset&lt;/legend&gt;
  &lt;p&gt;
   &lt;label&gt;Name: &lt;input type="name" name="radio" value="regular"&gt; Regular &lt;/label&gt;
  &lt;/p&gt;
  &lt;p&gt;
   &lt;label&gt;Number: &lt;input type="number"&gt;&lt;/label&gt;
  &lt;/p&gt;
&lt;/fieldset&gt;
</pre>

<p>{{EmbedLiveSample('Examples', 500, 300)}}</p>
</div>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', 'forms.html#attr-input-disabled', 'disabled attribute')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5 W3C', 'forms.html#attr-input-disabled', 'disabled attribute')}}</td>
   <td>{{Spec2('HTML5 W3C')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5.1', 'sec-forms.html#the-disabled-attribute', 'disabled attribute')}}</td>
   <td>{{Spec2('HTML5.1')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("html.elements.attributes.disabled")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{cssxref(':disabled')}} and {{cssxref(':enabled')}}</li>
</ul>
